--log(serpent.line(data.raw["ammo-turret"]["gun-turret"]) )


-- local new_line = [[ 
-- ]]
local new_line = string.char(10)


function indexing (text)
	--string.find(s, pattern [, index [, plain]])
	local pos_or_nil = string.find(text, '-')
	if not pos_or_nil then 
		if type (text) == "string" then
			--log (text .. ' was string!')
			return  '.' .. text
		else
			return  '[' .. text .. ']'
		end
	else -- only text has '-' inside, not the number
		return '["' .. text .. '"]'
	end
	log ("Error")
end

function for_serpent (tabl)
  local n_amount = #tabl
  local last_index = 0
  local t_amount = 0
  for i, v in pairs (tabl) do
    if (type (v) == 'table') then
      return false
    end
    t_amount = t_amount + 1
    last_index = i
  end
  if n_amount == t_amount then
    return true
  end
  if t_amount <= 4 then
    return true
  end
  return false
end

function self (table_or_value, path, deep)
  local my_big_string = ''
  if type(table_or_value) == "table" then
    for index in pairs (table_or_value) do
      if index ~= 'autoplace' then
        if for_serpent (table_or_value) then
          -- my_big_string = my_big_string .. serpent.line (table_or_value) .. new_line
          my_big_string = path .. ' = ' ..  serpent.line (table_or_value, {sortkeys = false}) .. new_line
        else
          my_big_string = my_big_string .. self (table_or_value[index], path .. indexing(index), deep+1)
        end
      else
        my_big_string = my_big_string .. ' (hidden)' .. new_line
      end
    end
  else
    if type(table_or_value) ~= "function" then
      if type(table_or_value) == "string" then
       my_big_string = path .. ' = "' .. tostring(table_or_value) .. '"' .. new_line
      else	
       my_big_string = path .. ' = ' .. tostring(table_or_value) .. new_line
      end
    end
  end
  
  if deep < 3 and not (my_big_string == '') then
    log (path..' = '..'{'..new_line..my_big_string..'}')
    my_big_string = ''
  end
  return my_big_string
end


local deep = 0
for i, v in pairs( {data=data, defines=defines} ) do
  self(v, i, deep)
end


